diff --git a/gcc/ipa-inline.c b/gcc/ipa-inline.c
index f6f97f8..4982a44 100644
--- a/gcc/ipa-inline.c
+++ b/gcc/ipa-inline.c
@@ -240,7 +240,7 @@ static bool
 sanitize_attrs_match_for_inline_p (const_tree caller, const_tree callee)
 {
   /* Don't care if sanitizer is disabled */
-  if (!(flag_sanitize & SANITIZE_ADDRESS))
+  if (!(GCC_OPTION (flag_sanitize) & SANITIZE_ADDRESS))
     return true;
 
   if (!caller || !callee)
@@ -450,7 +450,7 @@ want_early_inline_function_p (struct cgraph_edge *e)
   if (DECL_DISREGARD_INLINE_LIMITS (callee->decl))
     ;
   else if (!DECL_DECLARED_INLINE_P (callee->decl)
-	   && !flag_inline_small_functions)
+	   && !GCC_OPTION (flag_inline_small_functions))
     {
       e->inline_failed = CIF_FUNCTION_NOT_INLINE_CANDIDATE;
       report_inline_failed_reason (e);
@@ -568,7 +568,7 @@ want_inline_small_function_p (struct cgraph_edge *e, bool report)
   if (DECL_DISREGARD_INLINE_LIMITS (callee->decl))
     ;
   else if (!DECL_DECLARED_INLINE_P (callee->decl)
-	   && !flag_inline_small_functions)
+	   && !GCC_OPTION (flag_inline_small_functions))
     {
       e->inline_failed = CIF_FUNCTION_NOT_INLINE_CANDIDATE;
       want_inline = false;
@@ -631,7 +631,7 @@ want_inline_small_function_p (struct cgraph_edge *e, bool report)
 		&& estimate_growth (callee) <= 0)
 	;
       else if (!DECL_DECLARED_INLINE_P (callee->decl)
-	       && !flag_inline_functions)
+	       && !GCC_OPTION (flag_inline_functions))
 	{
           e->inline_failed = CIF_NOT_DECLARED_INLINED;
 	  want_inline = false;
@@ -991,7 +991,7 @@ edge_badness (struct cgraph_edge *edge, bool dump)
 
      compensated by the inline hints.
   */
-  else if (flag_guess_branch_prob)
+  else if (GCC_OPTION (flag_guess_branch_prob))
     {
       badness = (relative_time_benefit (callee_info, edge, edge_time)
 		 * (INT_MIN / 16 / RELATIVE_TIME_BENEFIT_RANGE));
@@ -1568,7 +1568,7 @@ inline_small_functions (void)
   struct cgraph_node **order = XCNEWVEC (struct cgraph_node *, cgraph_n_nodes);
   struct cgraph_edge_hook_list *edge_removal_hook_holder;
 
-  if (flag_indirect_inlining)
+  if (GCC_OPTION (flag_indirect_inlining))
     new_indirect_edges.create (8);
 
   edge_removal_hook_holder
@@ -1669,9 +1669,9 @@ inline_small_functions (void)
 	}
     }
 
-  gcc_assert (in_lto_p
+  gcc_assert (GCC_OPTION (in_lto_p)
 	      || !max_count
-	      || (profile_info && flag_branch_probabilities));
+	      || (profile_info && GCC_OPTION (flag_branch_probabilities)));
 
   while (!fibheap_empty (edge_heap))
     {
@@ -1726,9 +1726,9 @@ inline_small_functions (void)
 		   " Estimated growth after inlined into all is %+i insns.\n"
 		   " Estimated badness is %i, frequency %.2f.\n",
 		   edge->caller->name (), edge->caller->order,
-		   flag_wpa ? "unknown"
+		   GCC_OPTION (flag_wpa) ? "unknown"
 		   : gimple_filename ((const_gimple) edge->call_stmt),
-		   flag_wpa ? -1
+		   GCC_OPTION (flag_wpa) ? -1
 		   : gimple_lineno ((const_gimple) edge->call_stmt),
 		   estimate_growth (callee),
 		   badness,
@@ -1765,7 +1765,7 @@ inline_small_functions (void)
 	  if (where->global.inlined_to)
 	    where = where->global.inlined_to;
 	  if (!recursive_inlining (edge,
-				   flag_indirect_inlining
+				   GCC_OPTION (flag_indirect_inlining)
 				   ? &new_indirect_edges : NULL))
 	    {
 	      edge->inline_failed = CIF_RECURSIVE_INLINING;
@@ -1775,7 +1775,7 @@ inline_small_functions (void)
 	  reset_edge_caches (where);
 	  /* Recursive inliner inlines all recursive calls of the function
 	     at once. Consequently we need to update all callee keys.  */
-	  if (flag_indirect_inlining)
+	  if (GCC_OPTION (flag_indirect_inlining))
 	    add_new_edges_to_heap (edge_heap, new_indirect_edges);
           update_callee_keys (edge_heap, where, updated_nodes);
 	  bitmap_clear (updated_nodes);
@@ -1813,7 +1813,7 @@ inline_small_functions (void)
 
 	  gcc_checking_assert (!callee->global.inlined_to);
 	  inline_call (edge, true, &new_indirect_edges, &overall_size, true);
-	  if (flag_indirect_inlining)
+	  if (GCC_OPTION (flag_indirect_inlining))
 	    add_new_edges_to_heap (edge_heap, new_indirect_edges);
 
 	  reset_edge_caches (edge->callee);
@@ -2013,12 +2013,12 @@ ipa_inline (void)
   int cold;
   bool remove_functions = false;
 
-  if (!optimize)
+  if (!GCC_OPTION (optimize))
     return 0;
 
   order = XCNEWVEC (struct cgraph_node *, cgraph_n_nodes);
 
-  if (in_lto_p && optimize)
+  if (GCC_OPTION (in_lto_p) && GCC_OPTION (optimize))
     ipa_update_after_lto_read ();
 
   if (dump_file)
@@ -2108,7 +2108,7 @@ ipa_inline (void)
 	      reset_edge_caches (where);
 	      inline_update_overall_summary (where);
 	    }
-	  if (flag_inline_functions_called_once
+	  if (GCC_OPTION (flag_inline_functions_called_once)
 	      && want_inline_function_to_all_callers_p (node, cold))
 	    {
 	      int num_calls = 0;
@@ -2122,7 +2122,7 @@ ipa_inline (void)
     }
 
   /* Free ipa-prop structures if they are no longer needed.  */
-  if (optimize)
+  if (GCC_OPTION (optimize))
     ipa_free_all_structures_after_iinln ();
 
   if (dump_file)
@@ -2133,7 +2133,7 @@ ipa_inline (void)
   if (dump_file)
     dump_inline_summaries (dump_file);
   /* In WPA we use inline summaries for partitioning process.  */
-  if (!flag_wpa)
+  if (!GCC_OPTION (flag_wpa))
     inline_free_summary ();
   return remove_functions ? TODO_remove_functions : 0;
 }
@@ -2203,8 +2203,8 @@ early_inline_small_functions (struct cgraph_node *node)
 
       /* Do not consider functions not declared inline.  */
       if (!DECL_DECLARED_INLINE_P (callee->decl)
-	  && !flag_inline_small_functions
-	  && !flag_inline_functions)
+	  && !GCC_OPTION (flag_inline_small_functions)
+	  && !GCC_OPTION (flag_inline_functions))
 	continue;
 
       if (dump_file)
@@ -2268,9 +2268,9 @@ early_inliner (void)
      functions.  */
   inlined = inline_always_inline_functions (node);
 
-  if (!optimize
-      || flag_no_inline
-      || !flag_early_inlining
+  if (!GCC_OPTION (optimize)
+      || GCC_OPTION (flag_no_inline)
+      || !GCC_OPTION (flag_early_inlining)
       /* Never inline regular functions into always-inline functions
 	 during incremental inlining.  This sucks as functions calling
 	 always inline functions will get less optimized, but at the
diff --git a/gcc/ipa-profile.c b/gcc/ipa-profile.c
index 17de687..096abb3 100644
--- a/gcc/ipa-profile.c
+++ b/gcc/ipa-profile.c
@@ -339,7 +339,7 @@ ipa_propagate_frequency_1 (struct cgraph_node *node, void *data)
 	 errors can make us to push function into unlikely section even when
 	 it is executed by the train run.  Transfer the function only if all
 	 callers are unlikely executed.  */
-      if (profile_info && flag_branch_probabilities
+      if (profile_info && GCC_OPTION (flag_branch_probabilities)
 	  && (edge->caller->frequency != NODE_FREQUENCY_UNLIKELY_EXECUTED
 	      || (edge->caller->global.inlined_to
 		  && edge->caller->global.inlined_to->frequency
@@ -406,7 +406,7 @@ ipa_propagate_frequency (struct cgraph_node *node)
      nor about virtuals.  */
   if (!node->local.local
       || node->alias
-      || (flag_devirtualize && DECL_VIRTUAL_P (node->decl)))
+      || (GCC_OPTION (flag_devirtualize) && DECL_VIRTUAL_P (node->decl)))
     return false;
   gcc_assert (node->analyzed);
   if (dump_file && (dump_flags & TDF_DETAILS))
@@ -558,7 +558,7 @@ ipa_profile (void)
 		   cumulated_size * 100.0 / overall_size);
 	}
       if (threshold > get_hot_bb_threshold ()
-	  || in_lto_p)
+	  || GCC_OPTION (in_lto_p))
 	{
 	  if (dump_file)
 	    fprintf (dump_file, "Threshold updated.\n");
@@ -714,7 +714,7 @@ ipa_profile (void)
 static bool
 gate_ipa_profile (void)
 {
-  return flag_ipa_profile;
+  return GCC_OPTION (flag_ipa_profile);
 }
 
 namespace {
diff --git a/gcc/ipa-prop.c b/gcc/ipa-prop.c
index 9f144fa..4ea92d2 100644
--- a/gcc/ipa-prop.c
+++ b/gcc/ipa-prop.c
@@ -395,7 +395,7 @@ ipa_set_jf_known_type (struct ipa_jump_func *jfunc, HOST_WIDE_INT offset,
 {
   gcc_assert (TREE_CODE (component_type) == RECORD_TYPE
 	      && TYPE_BINFO (component_type));
-  if (!flag_devirtualize)
+  if (!GCC_OPTION (flag_devirtualize))
     return;
   gcc_assert (BINFO_VTABLE (TYPE_BINFO (component_type)));
   jfunc->type = IPA_JF_KNOWN_TYPE;
@@ -482,7 +482,7 @@ ipa_set_ancestor_jf (struct ipa_jump_func *jfunc, HOST_WIDE_INT offset,
 		     tree type, int formal_id, bool agg_preserved,
 		     bool type_preserved)
 {
-  if (!flag_devirtualize)
+  if (!GCC_OPTION (flag_devirtualize))
     type_preserved = false;
   gcc_assert (!type_preserved
 	      || (TREE_CODE (type) == RECORD_TYPE
@@ -580,7 +580,7 @@ stmt_may_be_vtbl_ptr_store (gimple stmt)
 
       if (!AGGREGATE_TYPE_P (TREE_TYPE (lhs)))
 	{
-	  if (flag_strict_aliasing
+	  if (GCC_OPTION (flag_strict_aliasing)
 	      && !POINTER_TYPE_P (TREE_TYPE (lhs)))
 	    return false;
 
@@ -690,7 +690,7 @@ detect_type_change (tree arg, tree base, tree comp_type, gimple call,
 		       || handled_component_p (arg));
   /* Const calls cannot call virtual methods through VMT and so type changes do
      not matter.  */
-  if (!flag_devirtualize || !gimple_vuse (call)
+  if (!GCC_OPTION (flag_devirtualize) || !gimple_vuse (call)
       /* Be sure expected_type is polymorphic.  */
       || !comp_type
       || TREE_CODE (comp_type) != RECORD_TYPE
@@ -747,7 +747,7 @@ detect_type_change_ssa (tree arg, tree comp_type,
 			gimple call, struct ipa_jump_func *jfunc)
 {
   gcc_checking_assert (TREE_CODE (arg) == SSA_NAME);
-  if (!flag_devirtualize
+  if (!GCC_OPTION (flag_devirtualize)
       || !POINTER_TYPE_P (TREE_TYPE (arg)))
     return false;
 
@@ -1264,7 +1264,7 @@ compute_known_type_jump_func (tree op, struct ipa_jump_func *jfunc,
   HOST_WIDE_INT offset, size, max_size;
   tree base;
 
-  if (!flag_devirtualize
+  if (!GCC_OPTION (flag_devirtualize)
       || TREE_CODE (op) != ADDR_EXPR
       || TREE_CODE (TREE_TYPE (TREE_TYPE (op))) != RECORD_TYPE
       /* Be sure expected_type is polymorphic.  */
@@ -1706,7 +1706,7 @@ ipa_compute_jump_functions (struct cgraph_node *node,
 								  NULL);
       /* We do not need to bother analyzing calls to unknown
 	 functions unless they may become known during lto/whopr.  */
-      if (!callee->definition && !flag_lto)
+      if (!callee->definition && !GCC_OPTION (flag_lto))
 	continue;
       ipa_compute_jump_functions_for_edge (parms_ainfo, cs);
     }
@@ -2011,7 +2011,7 @@ ipa_analyze_virtual_call_uses (struct cgraph_node *node,
   int index;
   HOST_WIDE_INT anc_offset;
 
-  if (!flag_devirtualize)
+  if (!GCC_OPTION (flag_devirtualize))
     return;
 
   if (TREE_CODE (obj) != SSA_NAME)
@@ -2714,7 +2714,7 @@ try_make_edge_direct_virtual_call (struct cgraph_edge *ie,
 {
   tree binfo, target;
 
-  if (!flag_devirtualize)
+  if (!GCC_OPTION (flag_devirtualize))
     return NULL;
 
   /* First try to do lookup via known virtual table pointer value.  */
@@ -2844,7 +2844,7 @@ update_indirect_edges_after_inlining (struct cgraph_edge *cs,
       param_index = ici->param_index;
       jfunc = ipa_get_ith_jump_func (top, param_index);
 
-      if (!flag_indirect_inlining)
+      if (!GCC_OPTION (flag_indirect_inlining))
 	new_direct_edge = NULL;
       else if (ici->polymorphic)
 	new_direct_edge = try_make_edge_direct_virtual_call (ie, jfunc,
@@ -3374,7 +3374,7 @@ ipa_unregister_cgraph_hooks (void)
 void
 ipa_free_all_structures_after_ipa_cp (void)
 {
-  if (!optimize)
+  if (!GCC_OPTION (optimize))
     {
       ipa_free_all_edge_args ();
       ipa_free_all_node_params ();
@@ -3460,7 +3460,7 @@ ipa_get_vector_of_formal_parms (tree fndecl)
   int count;
   tree parm;
 
-  gcc_assert (!flag_wpa);
+  gcc_assert (!GCC_OPTION (flag_wpa));
   count = count_formal_params (fndecl);
   args.create (count);
   for (parm = DECL_ARGUMENTS (fndecl); parm; parm = DECL_CHAIN (parm))
diff --git a/gcc/ipa-prop.h b/gcc/ipa-prop.h
index 8fdd92c..c88bc57 100644
--- a/gcc/ipa-prop.h
+++ b/gcc/ipa-prop.h
@@ -403,7 +403,7 @@ ipa_get_param_count (struct ipa_node_params *info)
 static inline tree
 ipa_get_param (struct ipa_node_params *info, int i)
 {
-  gcc_checking_assert (!flag_wpa);
+  gcc_checking_assert (!GCC_OPTION (flag_wpa));
   return info->descriptors[i].decl;
 }
 
diff --git a/gcc/ipa-pure-const.c b/gcc/ipa-pure-const.c
index 296f9c0..9f4a3e2 100644
--- a/gcc/ipa-pure-const.c
+++ b/gcc/ipa-pure-const.c
@@ -579,7 +579,7 @@ check_call (funct_state local, gimple call, bool ipa)
       state_from_flags (&call_state, &call_looping, flags,
 			((flags & (ECF_NORETURN | ECF_NOTHROW))
 			 == (ECF_NORETURN | ECF_NOTHROW))
-			|| (!flag_exceptions && (flags & ECF_NORETURN)));
+			|| (!GCC_OPTION (flag_exceptions) && (flags & ECF_NORETURN)));
       worse_state (&local->pure_const_state, &local->looping,
 		   call_state, call_looping);
     }
@@ -1493,7 +1493,7 @@ propagate (void)
 static bool
 gate_pure_const (void)
 {
-  return (flag_ipa_pure_const
+  return (GCC_OPTION (flag_ipa_pure_const)
 	  /* Don't bother doing anything if the program has errors.  */
 	  && !seen_error ());
 }
@@ -1582,8 +1582,8 @@ local_pure_const (void)
 
   node = cgraph_get_node (current_function_decl);
   skip = skip_function_for_local_pure_const (node);
-  if (!warn_suggest_attribute_const
-      && !warn_suggest_attribute_pure
+  if (!GCC_OPTION (warn_suggest_attribute_const)
+      && !GCC_OPTION (warn_suggest_attribute_pure)
       && skip)
     return 0;
 
@@ -1735,7 +1735,7 @@ execute_warn_function_noreturn (void)
 static bool
 gate_warn_function_noreturn (void)
 {
-  return warn_suggest_attribute_noreturn;
+  return GCC_OPTION (warn_suggest_attribute_noreturn);
 }
 
 namespace {
diff --git a/gcc/ipa-reference.c b/gcc/ipa-reference.c
index dbe32e4..6f7c305 100644
--- a/gcc/ipa-reference.c
+++ b/gcc/ipa-reference.c
@@ -1151,7 +1151,7 @@ ipa_reference_read_optimization_summary (void)
 static bool
 gate_reference (void)
 {
-  return (flag_ipa_reference
+  return (GCC_OPTION (flag_ipa_reference)
 	  /* Don't bother doing anything if the program has errors.  */
 	  && !seen_error ());
 }
diff --git a/gcc/ipa-split.c b/gcc/ipa-split.c
index 38bd883..7522aff 100644
--- a/gcc/ipa-split.c
+++ b/gcc/ipa-split.c
@@ -1571,7 +1571,7 @@ execute_split_functions (void)
        /* Local functions called once will be completely inlined most of time.  */
        || (!node->callers->next_caller && node->local.local))
       && !node->address_taken
-      && (!flag_lto || !node->externally_visible))
+      && (!GCC_OPTION (flag_lto) || !node->externally_visible))
     {
       if (dump_file)
 	fprintf (dump_file, "Not splitting: not called directly "
@@ -1580,7 +1580,7 @@ execute_split_functions (void)
     }
 
   /* FIXME: We can actually split if splitting reduces call overhead.  */
-  if (!flag_inline_small_functions
+  if (!GCC_OPTION (flag_inline_small_functions)
       && !DECL_DECLARED_INLINE_P (current_function_decl))
     {
       if (dump_file)
@@ -1653,8 +1653,8 @@ execute_split_functions (void)
 static bool
 gate_split_functions (void)
 {
-  return (flag_partial_inlining
-	  && !profile_arc_flag && !flag_branch_probabilities);
+  return (GCC_OPTION (flag_partial_inlining)
+	  && !GCC_OPTION (profile_arc_flag) && !GCC_OPTION (flag_branch_probabilities));
 }
 
 namespace {
@@ -1702,8 +1702,8 @@ make_pass_split_functions (gcc::context *ctxt)
 static bool
 gate_feedback_split_functions (void)
 {
-  return (flag_partial_inlining
-	  && flag_branch_probabilities);
+  return (GCC_OPTION (flag_partial_inlining)
+	  && GCC_OPTION (flag_branch_probabilities));
 }
 
 /* Execute function splitting pass.  */
diff --git a/gcc/ipa.c b/gcc/ipa.c
index 572dba1..6d675be 100644
--- a/gcc/ipa.c
+++ b/gcc/ipa.c
@@ -144,7 +144,7 @@ process_references (struct ipa_ref_list *list,
 		     constant folding.  Keep references alive so partitioning
 		     knows about potential references.  */
 		  || (TREE_CODE (node->decl) == VAR_DECL
-		      && flag_wpa
+		      && GCC_OPTION (flag_wpa)
 		      && ctor_for_folding (node->decl)
 		         != error_mark_node))))
 	pointer_set_insert (reachable, node);
@@ -301,7 +301,7 @@ symtab_remove_unreachable_nodes (bool before_inlining_p, FILE *file)
 #ifdef ENABLE_CHECKING
   verify_symtab ();
 #endif
-  if (optimize && flag_devirtualize)
+  if (GCC_OPTION (optimize) && GCC_OPTION (flag_devirtualize))
     build_type_inheritance_graph ();
   if (file)
     fprintf (file, "\nReclaiming functions:");
@@ -389,7 +389,7 @@ symtab_remove_unreachable_nodes (bool before_inlining_p, FILE *file)
 	    {
 	      struct cgraph_edge *e;
 	      /* Keep alive possible targets for devirtualization.  */
-	      if (optimize && flag_devirtualize)
+	      if (GCC_OPTION (optimize) && GCC_OPTION (flag_devirtualize))
 		{
 		  struct cgraph_edge *next;
 		  for (e = cnode->indirect_calls; e; e = next)
@@ -479,7 +479,7 @@ symtab_remove_unreachable_nodes (bool before_inlining_p, FILE *file)
 	  if (!pointer_set_contains (body_needed_for_clonning, node->decl))
 	    cgraph_release_function_body (node);
 	  else if (!node->clone_of)
-	    gcc_assert (in_lto_p || DECL_RESULT (node->decl));
+	    gcc_assert (GCC_OPTION (in_lto_p) || DECL_RESULT (node->decl));
 	  if (node->definition)
 	    {
 	      if (file)
@@ -498,7 +498,7 @@ symtab_remove_unreachable_nodes (bool before_inlining_p, FILE *file)
 	}
       else
 	gcc_assert (node->clone_of || !cgraph_function_with_gimple_body_p (node)
-		    || in_lto_p || DECL_RESULT (node->decl));
+		    || GCC_OPTION (in_lto_p) || DECL_RESULT (node->decl));
     }
 
   /* Inline clones might be kept around so their materializing allows further
@@ -526,7 +526,7 @@ symtab_remove_unreachable_nodes (bool before_inlining_p, FILE *file)
 	  /* For can_refer_decl_in_current_unit_p we want to track for
 	     all external variables if they are defined in other partition
 	     or not.  */
-	  && (!flag_ltrans || !DECL_EXTERNAL (vnode->decl)))
+	  && (!GCC_OPTION (flag_ltrans) || !DECL_EXTERNAL (vnode->decl)))
 	{
 	  if (file)
 	    fprintf (file, " %s", vnode->name ());
@@ -590,7 +590,7 @@ symtab_remove_unreachable_nodes (bool before_inlining_p, FILE *file)
 #endif
 
   /* If we removed something, perhaps profile could be improved.  */
-  if (changed && optimize && inline_edge_summary_vec.exists ())
+  if (changed && GCC_OPTION (optimize) && inline_edge_summary_vec.exists ())
     FOR_EACH_DEFINED_FUNCTION (node)
       ipa_propagate_frequency (node);
 
@@ -702,7 +702,7 @@ comdat_can_be_unshared_p_1 (symtab_node *node)
   if (node->forced_by_abi
       && TREE_PUBLIC (node->decl)
       && (node->resolution != LDPR_PREVAILING_DEF_IRONLY
-          && !flag_whole_program))
+          && !GCC_OPTION (flag_whole_program)))
     return false;
 
   /* Non-readonly and volatile variables can not be duplicated.  */
@@ -780,13 +780,13 @@ cgraph_externally_visible_p (struct cgraph_node *node,
      This improves code quality and we know we will duplicate them at most twice
      (in the case that we are not using plugin and link with object file
       implementing same COMDAT)  */
-  if ((in_lto_p || whole_program)
+  if ((GCC_OPTION (in_lto_p) || whole_program)
       && DECL_COMDAT (node->decl)
       && comdat_can_be_unshared_p (node))
     return false;
 
   /* When doing link time optimizations, hidden symbols become local.  */
-  if (in_lto_p
+  if (GCC_OPTION (in_lto_p)
       && (DECL_VISIBILITY (node->decl) == VISIBILITY_HIDDEN
 	  || DECL_VISIBILITY (node->decl) == VISIBILITY_INTERNAL)
       /* Be sure that node is defined in IR file, not in other object
@@ -845,20 +845,20 @@ varpool_externally_visible_p (varpool_node *vnode)
      so this does not enable more optimization, but referring static var
      is faster for dynamic linking.  Also this match logic hidding vtables
      from LTO symbol tables.  */
-  if ((in_lto_p || flag_whole_program)
+  if ((GCC_OPTION (in_lto_p) || GCC_OPTION (flag_whole_program))
       && DECL_COMDAT (vnode->decl)
       && comdat_can_be_unshared_p (vnode))
     return false;
 
   /* When doing link time optimizations, hidden symbols become local.  */
-  if (in_lto_p
+  if (GCC_OPTION (in_lto_p)
       && (DECL_VISIBILITY (vnode->decl) == VISIBILITY_HIDDEN
 	  || DECL_VISIBILITY (vnode->decl) == VISIBILITY_INTERNAL)
       /* Be sure that node is defined in IR file, not in other object
 	 file.  In that case we don't set used_from_other_object_file.  */
       && vnode->definition)
     ;
-  else if (!flag_whole_program)
+  else if (!GCC_OPTION (flag_whole_program))
     return true;
 
   /* Do not attempt to privatize COMDATS by default.
@@ -909,7 +909,7 @@ function_and_variable_visibility (bool whole_program)
       int flags = flags_from_decl_or_type (node->decl);
 
       /* Optimize away PURE and CONST constructors and destructors.  */
-      if (optimize
+      if (GCC_OPTION (optimize)
 	  && (flags & (ECF_CONST | ECF_PURE))
 	  && !(flags & ECF_LOOPING_CONST_OR_PURE))
 	{
@@ -968,7 +968,7 @@ function_and_variable_visibility (bool whole_program)
 	  && node->definition && !node->weakref
 	  && !DECL_EXTERNAL (node->decl))
 	{
-	  gcc_assert (whole_program || in_lto_p
+	  gcc_assert (whole_program || GCC_OPTION (in_lto_p)
 		      || !TREE_PUBLIC (node->decl));
 	  node->unique_name = ((node->resolution == LDPR_PREVAILING_DEF_IRONLY
 				|| node->unique_name
@@ -1130,7 +1130,7 @@ function_and_variable_visibility (bool whole_program)
       if (!vnode->externally_visible
 	  && !vnode->weakref)
 	{
-	  gcc_assert (in_lto_p || whole_program || !TREE_PUBLIC (vnode->decl));
+	  gcc_assert (GCC_OPTION (in_lto_p) || whole_program || !TREE_PUBLIC (vnode->decl));
 	  vnode->unique_name = ((vnode->resolution == LDPR_PREVAILING_DEF_IRONLY
 				       || vnode->resolution == LDPR_PREVAILING_DEF_IRONLY_EXP)
 				       && TREE_PUBLIC (vnode->decl));
@@ -1169,7 +1169,7 @@ function_and_variable_visibility (bool whole_program)
 static unsigned int
 local_function_and_variable_visibility (void)
 {
-  return function_and_variable_visibility (flag_whole_program && !flag_lto);
+  return function_and_variable_visibility (GCC_OPTION (flag_whole_program) && !GCC_OPTION (flag_lto));
 }
 
 namespace {
@@ -1263,7 +1263,7 @@ make_pass_ipa_free_inline_summary (gcc::context *ctxt)
 static bool
 gate_whole_program_function_and_variable_visibility (void)
 {
-  return !flag_ltrans;
+  return !GCC_OPTION (flag_ltrans);
 }
 
 /* Bring functionss local at LTO time with -fwhole-program.  */
@@ -1271,8 +1271,8 @@ gate_whole_program_function_and_variable_visibility (void)
 static unsigned int
 whole_program_function_and_variable_visibility (void)
 {
-  function_and_variable_visibility (flag_whole_program);
-  if (optimize)
+  function_and_variable_visibility (GCC_OPTION (flag_whole_program));
+  if (GCC_OPTION (optimize))
     ipa_discover_readonly_nonaddressable_vars ();
   return 0;
 }
@@ -1567,14 +1567,14 @@ build_cdtor_fns (void)
 {
   if (!static_ctors.is_empty ())
     {
-      gcc_assert (!targetm.have_ctors_dtors || in_lto_p);
+      gcc_assert (!targetm.have_ctors_dtors || GCC_OPTION (in_lto_p));
       static_ctors.qsort (compare_ctor);
       build_cdtor (/*ctor_p=*/true, static_ctors);
     }
 
   if (!static_dtors.is_empty ())
     {
-      gcc_assert (!targetm.have_ctors_dtors || in_lto_p);
+      gcc_assert (!targetm.have_ctors_dtors || GCC_OPTION (in_lto_p));
       static_dtors.qsort (compare_dtor);
       build_cdtor (/*ctor_p=*/false, static_dtors);
     }
@@ -1607,7 +1607,7 @@ ipa_cdtor_merge (void)
 static bool
 gate_ipa_cdtor_merge (void)
 {
-  return !targetm.have_ctors_dtors || (optimize && in_lto_p);
+  return !targetm.have_ctors_dtors || (GCC_OPTION (optimize) && GCC_OPTION (in_lto_p));
 }
 
 namespace {
diff --git a/gcc/ira-build.c b/gcc/ira-build.c
index 0396f37..980d049 100644
--- a/gcc/ira-build.c
+++ b/gcc/ira-build.c
@@ -2024,8 +2024,8 @@ propagate_allocno_info (void)
   ira_loop_tree_node_t parent;
   enum reg_class aclass;
 
-  if (flag_ira_region != IRA_REGION_ALL
-      && flag_ira_region != IRA_REGION_MIXED)
+  if (GCC_OPTION (flag_ira_region) != IRA_REGION_ALL
+      && GCC_OPTION (flag_ira_region) != IRA_REGION_MIXED)
     return;
   for (i = max_reg_num () - 1; i >= FIRST_PSEUDO_REGISTER; i--)
     for (a = ira_regno_allocno_map[i];
@@ -2074,7 +2074,7 @@ create_allocnos (void)
      next_regno_allocno.  */
   ira_traverse_loop_tree (true, ira_loop_tree_root,
 			  create_loop_tree_node_allocnos, NULL);
-  if (optimize)
+  if (GCC_OPTION (optimize))
     ira_traverse_loop_tree (false, ira_loop_tree_root, NULL,
 			    propagate_modified_regnos);
 }
diff --git a/gcc/ira-color.c b/gcc/ira-color.c
index c20aaf7..6f05bf4 100644
--- a/gcc/ira-color.c
+++ b/gcc/ira-color.c
@@ -2975,7 +2975,7 @@ color_allocnos (void)
 	    ira_remove_pref (pref);
 	}
     }
-  if (flag_ira_algorithm == IRA_ALGORITHM_PRIORITY)
+  if (GCC_OPTION (flag_ira_algorithm) == IRA_ALGORITHM_PRIORITY)
     {
       n = 0;
       EXECUTE_IF_SET_IN_BITMAP (coloring_allocno_bitmap, 0, i, bi)
@@ -3176,8 +3176,8 @@ color_pass (ira_loop_tree_node_t loop_tree_node)
   /* Color all mentioned allocnos including transparent ones.  */
   color_allocnos ();
   /* Process caps.  They are processed just once.  */
-  if (flag_ira_region == IRA_REGION_MIXED
-      || flag_ira_region == IRA_REGION_ALL)
+  if (GCC_OPTION (flag_ira_region) == IRA_REGION_MIXED
+      || GCC_OPTION (flag_ira_region) == IRA_REGION_ALL)
     EXECUTE_IF_SET_IN_BITMAP (loop_tree_node->all_allocnos, 0, j, bi)
       {
 	a = ira_allocnos[j];
@@ -3187,7 +3187,7 @@ color_pass (ira_loop_tree_node_t loop_tree_node)
 	bitmap_clear_bit (consideration_allocno_bitmap, j);
 	rclass = ALLOCNO_CLASS (a);
 	pclass = ira_pressure_class_translate[rclass];
-	if (flag_ira_region == IRA_REGION_MIXED
+	if (GCC_OPTION (flag_ira_region) == IRA_REGION_MIXED
 	    && (loop_tree_node->reg_pressure[pclass]
 		<= ira_class_hard_regs_num[pclass]))
 	  {
@@ -3240,7 +3240,7 @@ color_pass (ira_loop_tree_node_t loop_tree_node)
 	  ira_assert (ALLOCNO_CLASS (subloop_allocno) == rclass);
 	  ira_assert (bitmap_bit_p (subloop_node->all_allocnos,
 				    ALLOCNO_NUM (subloop_allocno)));
-	  if ((flag_ira_region == IRA_REGION_MIXED)
+	  if ((GCC_OPTION (flag_ira_region) == IRA_REGION_MIXED)
 	      && (loop_tree_node->reg_pressure[pclass]
 		  <= ira_class_hard_regs_num[pclass]))
 	    {
@@ -4107,7 +4107,7 @@ ira_sort_regnos_for_alter_reg (int *pseudo_regnos, int n,
      sets.  */
   num = collect_spilled_coalesced_allocnos (pseudo_regnos, n,
 					    spilled_coalesced_allocnos);
-  if (flag_ira_share_spill_slots
+  if (GCC_OPTION (flag_ira_share_spill_slots)
       && coalesce_spill_slots (spilled_coalesced_allocnos, num))
     {
       setup_coalesced_allocno_costs_and_nums (pseudo_regnos, n);
@@ -4247,7 +4247,7 @@ allocno_reload_assign (ira_allocno_t a, HARD_REG_SET forbidden_regs)
       ira_object_t obj = ALLOCNO_OBJECT (a, i);
       COPY_HARD_REG_SET (saved[i], OBJECT_TOTAL_CONFLICT_HARD_REGS (obj));
       IOR_HARD_REG_SET (OBJECT_TOTAL_CONFLICT_HARD_REGS (obj), forbidden_regs);
-      if (! flag_caller_saves && ALLOCNO_CALLS_CROSSED_NUM (a) != 0)
+      if (! GCC_OPTION (flag_caller_saves) && ALLOCNO_CALLS_CROSSED_NUM (a) != 0)
 	IOR_HARD_REG_SET (OBJECT_TOTAL_CONFLICT_HARD_REGS (obj),
 			  call_used_reg_set);
     }
@@ -4272,7 +4272,7 @@ allocno_reload_assign (ira_allocno_t a, HARD_REG_SET forbidden_regs)
 	  && ira_hard_reg_set_intersection_p (hard_regno, ALLOCNO_MODE (a),
 					      call_used_reg_set))
 	{
-	  ira_assert (flag_caller_saves);
+	  ira_assert (GCC_OPTION (flag_caller_saves));
 	  caller_save_needed = 1;
 	}
     }
@@ -4420,7 +4420,7 @@ ira_reuse_stack_slot (int regno, unsigned int inherent_size,
   ira_assert (inherent_size == PSEUDO_REGNO_BYTES (regno)
 	      && inherent_size <= total_size
 	      && ALLOCNO_HARD_REGNO (allocno) < 0);
-  if (! flag_ira_share_spill_slots)
+  if (! GCC_OPTION (flag_ira_share_spill_slots))
     return NULL_RTX;
   slot_num = -ALLOCNO_HARD_REGNO (allocno) - 2;
   if (slot_num != -1)
diff --git a/gcc/ira-conflicts.c b/gcc/ira-conflicts.c
index c0b4f04..eac21d2 100644
--- a/gcc/ira-conflicts.c
+++ b/gcc/ira-conflicts.c
@@ -716,8 +716,8 @@ ira_build_conflicts (void)
 	  build_conflicts ();
 	  ira_traverse_loop_tree (true, ira_loop_tree_root, add_copies, NULL);
 	  /* We need finished conflict table for the subsequent call.  */
-	  if (flag_ira_region == IRA_REGION_ALL
-	      || flag_ira_region == IRA_REGION_MIXED)
+	  if (GCC_OPTION (flag_ira_region) == IRA_REGION_ALL
+	      || GCC_OPTION (flag_ira_region) == IRA_REGION_MIXED)
 	    propagate_copies ();
 
 	  /* Now we can free memory for the conflict table (see function
@@ -748,12 +748,12 @@ ira_build_conflicts (void)
 	  ira_object_t obj = ALLOCNO_OBJECT (a, i);
 	  rtx allocno_reg = regno_reg_rtx [ALLOCNO_REGNO (a)];
 
-	  if ((! flag_caller_saves && ALLOCNO_CALLS_CROSSED_NUM (a) != 0)
+	  if ((! GCC_OPTION (flag_caller_saves) && ALLOCNO_CALLS_CROSSED_NUM (a) != 0)
 	      /* For debugging purposes don't put user defined variables in
 		 callee-clobbered registers.  However, do allow parameters
 		 in callee-clobbered registers to improve debugging.  This
 		 is a bit of a fragile hack.  */
-	      || (optimize == 0
+	      || (GCC_OPTION (optimize) == 0
 		  && REG_USERVAR_P (allocno_reg)
 		  && ! reg_is_parm_p (allocno_reg)))
 	    {
@@ -792,7 +792,7 @@ ira_build_conflicts (void)
 	    }
 	}
     }
-  if (optimize && ira_conflicts_p
+  if (GCC_OPTION (optimize) && ira_conflicts_p
       && internal_flag_ira_verbose > 2 && ira_dump_file != NULL)
     print_conflicts (ira_dump_file, false);
 }
